package gomoku;

import gomoku.ComputerStrategyOpponentImplementation;

public class ComputerStrategyOpponent implements ComputerStrategy {

	public static final int WEAK = 1;
	public static final int ADVANCED = 2;
	@Override
	public String getName() {
		return "Weak strategy";
	}

	private ComputerStrategyOpponentImplementation opponent;

	public ComputerStrategyOpponent(int strength) {
		if (strength == WEAK) {
			opponent = new ComputerStrategyOpponentImplementation(ComputerStrategyOpponentImplementation.WEAK);
		} else if (strength == ADVANCED) {
			opponent = new ComputerStrategyOpponentImplementation(ComputerStrategyOpponentImplementation.ADVANCED);
		}
	}
	@Override
	public Location getMove(SimpleBoard board, int player) {
		int[][] b = board.getBoard();
		for (int row = 0; row < b.length; row++) {
			for (int col = 0; col < b[0].length; col++) {
				b[row][col] = b[row][col] == SimpleBoard.PLAYER_WHITE ? 2
						: (b[row][col] == SimpleBoard.PLAYER_BLACK ? 1 : 0);
			}
		}
		int[] move = opponent.getMove(b, player == SimpleBoard.PLAYER_WHITE ? 2 : 1);
		if (move == null)
			return null;
		return new Location(move[0], move[1]);
	}

}
